// WinModInsDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include <stdio.h>
#include <wingdi.h>
#include <mmsystem.h>
#include <winbase.h>
#include "WinModFileTypes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CWinModInsDlg 


CWinModInsDlg::CWinModInsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinModInsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinModInsDlg)
	//}}AFX_DATA_INIT
}

CWinModInsDlg::~CWinModInsDlg()
{
}

void CWinModInsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinModInsDlg)
	DDX_Control(pDX, IDC_SampleIndex, m_SampleIndexC);
	DDX_Control(pDX, IDC_Instrument_Volume, m_VolumeC);
	DDX_Control(pDX, IDC_Instrument_RepeatStop, m_RepeatStopC);
	DDX_Control(pDX, IDC_Instrument_RepeatStart, m_RepeatStartC);
	DDX_Control(pDX, IDC_Instrument_Name, m_SampleNameC);
	DDX_Control(pDX, IDC_Instrument_Length, m_LengthC);
	DDX_Control(pDX, IDC_Instrument_FineTune, m_FineTuneC);
	DDX_Control(pDX, IDC_Instrument_Basiston, m_BaseToneC);
	DDX_Control(pDX, IDC_Instrument_BaseFrequ, m_BaseFreqC);
	DDX_Control(pDX, IDC_CHECK_ISP, m_CheckISPC);
	DDX_Control(pDX, IDC_StopPlay, m_StopPlay);
	DDX_Control(pDX, IDC_PlayOnceButton, m_PlayOnceButton);
	DDX_Control(pDX, IDC_LIST_ActualNote, m_ActualPlayNote);
	DDX_Control(pDX, IDC_PrevSample, m_PrevButton);
	DDX_Control(pDX, IDC_NextSample, m_NextButton);
	DDX_Control(pDX, IDC_Bild, m_TheWave);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWinModInsDlg, CDialog)
	//{{AFX_MSG_MAP(CWinModInsDlg)
	ON_BN_CLICKED(IDC_NextSample, OnNextSample)
	ON_BN_CLICKED(IDC_PrevSample, OnPrevSample)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_PlayOnceButton, OnPlayOnceButton)
	ON_BN_CLICKED(IDC_StopPlay, OnStopPlay)
	ON_BN_CLICKED(IDC_CHECK_ISP, OnCheckIsp)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CWinModInsDlg 

void CWinModInsDlg::DrawSample()
{
	struct SampleData *ThisSample;
	unsigned int i;
	double facx,facy;
	CClientDC dc(&m_TheWave);
	RECT r;
    CPen MyPenRed (PS_SOLID, 1, RGB(255,0,0)),
		 MyPenGray(PS_SOLID, 1, RGB(125,125,125)), 
		 MyPenBlue(PS_SOLID, 1 ,RGB(0,0,255)), 
		 *OldPen;

	ThisSample=&ThisMod->Samples[ActSample];

	m_TheWave.GetClientRect(&r);
	r.top--;
	
	dc.FillSolidRect( &r, RGB(0,0,0));

	r.bottom--; r.right--; 

	OldPen=dc.SelectObject( &MyPenGray );
	dc.MoveTo(r.right,r.top+((r.bottom-r.top)/2));	
	dc.LineTo(r.left,r.top+((r.bottom-r.top)/2));

	if (ThisSample->Sample)
	{
		dc.SelectObject( &MyPenRed );
		
		facx=((double)(r.right-r.left))/(double)(ThisSample->Length);
		facy=((double)(r.bottom-r.top))/(double)65536;
		for (i=0; i<ThisSample->Length; i++)
		{
			double SampleValue;

			SampleValue=((double)(ThisSample->Sample[i])+(double)(32768))*facy;
			dc.LineTo((int)(r.left+(facx*i)),(int)(r.bottom-SampleValue));
		}

		if (ThisSample->RepeatStart || ThisSample->RepeatStop)
		{
			dc.SelectObject( &MyPenBlue );
			dc.MoveTo((int)(r.left+(facx*ThisSample->RepeatStart)), r.top);
			dc.LineTo((int)(r.left+(facx*ThisSample->RepeatStart)), r.bottom);
			dc.MoveTo((int)(r.left+(facx*(ThisSample->RepeatStop-1))), r.top);
			dc.LineTo((int)(r.left+(facx*(ThisSample->RepeatStop-1))), r.bottom);
		}
	}
		
	// Alten Pen zurcksetzen
	dc.SelectObject(OldPen);
}

void CWinModInsDlg::UpdateAllElements()
{
	struct SampleData *ThisSample;

	ThisSample=&ThisMod->Samples[ActSample];
	
	CString dummy;
	dummy.Format(_T("%u"), ActSample+1);
	m_SampleIndexC.SetWindowText(dummy); // Starte mit Nummer 1 - 31
	
	m_SampleNameC.SetWindowText(ThisSample->Name);
	
	dummy.Format(_T("%lu"), ThisSample->Length);
	m_LengthC.SetWindowText(dummy);
	
	dummy.Format(_T("%lu"), ThisSample->RepeatStart);
	m_RepeatStartC.SetWindowText(dummy);
	
	dummy.Format(_T("%lu"), ThisSample->RepeatStop);
	m_RepeatStopC.SetWindowText(dummy);
	
	dummy.Format(_T("%ld"), ThisSample->Volume);
	m_VolumeC.SetWindowText(dummy);
	
	m_BaseToneC.SetWindowText(GetNote(ThisSample->BaseTone));
	
	dummy.Format(_T("%lu"), ThisSample->BaseFrequenzy);
	m_BaseFreqC.SetWindowText(dummy);
	
	dummy.Format(_T("%d"), (int)ThisSample->FineTune);
	m_FineTuneC.SetWindowText(dummy);
	
	m_CheckISPC.SetCheck(PlayerISP);

	UpdateData(false);
}

BOOL CWinModInsDlg::OnInitDialog()
{
	extern CWinModApp theApp; // Das Applicationopjekt
	HICON hIconFor, hIconBack, hIconPlayOnce, hIconStopPlay;
	int i;
	struct SampleData *ThisSample;

	ThisSample=&ThisMod->Samples[0];

	CDialog::OnInitDialog();

	hIconFor=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_FORWARD));
	hIconBack=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_BACKWARDS));
	hIconPlayOnce=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_PlayOnceButton));
	hIconStopPlay=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_Stop));
	m_NextButton.SetIcon(hIconFor);
	m_PrevButton.SetIcon(hIconBack);
	m_PlayOnceButton.SetIcon(hIconPlayOnce);
	m_StopPlay.SetIcon(hIconStopPlay);

	for (i=0; i<nNotes; i++)
		m_ActualPlayNote.AddString(notes[i].NoteStr);
	m_ActualPlayNote.SetCurSel(GetNoteIndex(ThisSample->BaseTone));
	
	UpdateAllElements();

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CWinModInsDlg::OnNextSample() 
{
	ActSample++;
	if (ActSample>=ThisMod->nSamples) ActSample=0;

	m_ActualPlayNote.SetCurSel(m_ActualPlayNote.GetTopIndex());

	UpdateAllElements();
	DrawSample();
}

void CWinModInsDlg::OnPrevSample() 
{
	if (ActSample==0) ActSample=(ThisMod->nSamples)-1;
	else ActSample--;
	
	m_ActualPlayNote.SetCurSel(m_ActualPlayNote.GetTopIndex());

	UpdateAllElements();
	DrawSample();
}


void CWinModInsDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	DrawSample();
	// Kein Aufruf von CDialog::OnPaint() fr Zeichnungsnachrichten
}

bool CWinModInsDlg::FillBuffer(DWORD dwPos)
{
    long            lNumToWrite;
    DWORD           dwStartOfs;
    VOID            *lpvPtr1, *lpvPtr2;
	unsigned char   *Mylpv;
    DWORD           dwBytes1, dwBytes2, SamplesWritten, Tuning, SamplesToWrite;
	DWORD			nextSample;
	signed long s1,s2;
	WAVEHDR *current;

    if (dwStopNextTime == dwPos)   // All data has been played
    {
		bDone=true;
        StopBuffer();
        dwStopNextTime = 0xFFFF;
        return TRUE;
    }
 
	if (useWaveOut)
	{
		int realPos = (!dwPos)?(NUM_PLAY_NOTIFICATIONS - 1):dwPos-1;
		current = &blocks[realPos]; 

		if(current->dwFlags & WHDR_PREPARED) 
			waveOutUnprepareHeader(hWaveOut, current, sizeof(WAVEHDR));

		current->dwFlags=0;
		Mylpv=(unsigned char *)current->lpData;
		SamplesToWrite=current->dwBufferLength/(PlayerBitPerSample>>3);
	}
	else
	{
		if (dwPos == 0)
			dwStartOfs = rgdsbpn[NUM_PLAY_NOTIFICATIONS - 1].dwOffset;
		else
			dwStartOfs = rgdsbpn[dwPos-1].dwOffset;

		lNumToWrite = (LONG) rgdsbpn[dwPos].dwOffset - dwStartOfs;
		if (lNumToWrite < 0) lNumToWrite += dsbd.dwBufferBytes;

		IDirectSoundBuffer_Lock(g_pDSBuffer,
								dwStartOfs,       // Offset of lock start
								lNumToWrite,      // Number of bytes to lock
								&lpvPtr1,         // Address of lock start
								&dwBytes1,        // Count of bytes locked
								&lpvPtr2,         // Address of wrap around
								&dwBytes2,        // Count of wrap around bytes
								0);               // Flags
		
		Mylpv=(unsigned char *)lpvPtr1;
		SamplesToWrite=dwBytes1 / (PlayerBitPerSample>>3);
	}

	SamplesWritten=0;
	Tuning = (unsigned long)(((((double)BASETone)*((double)ActSampleData->BaseFrequenzy))/((double)PlayerFrequ)*FMULTI)/((double)ActNoteVal));
	
	while (SamplesWritten<SamplesToWrite)
	{
		if (SamplePos!=(unsigned long)0xFFFFFFFF)
		{
			SampleCount += Tuning;
			while (SampleCount>=LMULTI) 
			{
				SampleCount-=LMULTI;
				SamplePos++;
				if (ActSampleData->RepeatStop)
				{
					while (SamplePos>=ActSampleData->RepeatStop)
					{
						SamplePos-=ActSampleData->RepeatStop;
						SamplePos+=ActSampleData->RepeatStart;
					}
				}
				else
				if (SamplePos>=ActSampleData->Length)
				{
					SamplePos=(unsigned long)0xFFFFFFFF;
					break;
				}
			}
			
			if (SamplePos!=(unsigned long)0xFFFFFFFF)
			{
				s1=ActSampleData->Sample[SamplePos]<<QualityShift;

				// ISP:
				if (PlayerISP)
				{
					nextSample = SamplePos+1;
					if (ActSampleData->RepeatStop)
					{
						if (nextSample>=ActSampleData->RepeatStop)
						{
							nextSample-=ActSampleData->RepeatStop;
							nextSample+=ActSampleData->RepeatStart;
						}
					}
					if (nextSample>=ActSampleData->Length) 
						s2=0;
					else
						s2=ActSampleData->Sample[nextSample]<<QualityShift;
					
					s1+=(signed long)((((__int64)(s2-s1))*((__int64)(SampleCount)))/(__int64)(LMULTI));
					
					// Fine ISP
					OldSample=s1=(signed long)((((__int64)s1)+((__int64)OldSample))>>1);
				}
				
				s1=(signed long)( ( ((__int64)s1)* ((__int64)ActSampleData->Volume))/( ((__int64)MaxVolValue)<<1 ) )>>QualityShiftBack;
			}
			else
				s1 = 0;
		}
		else
			s1 = 0;

		if (PlayerBitPerSample==8)		// MONO 8-Bit
		{
			*(Mylpv++)=PromoteTo8Bit(s1>>8);
		}
		else							// MONO 16-Bit
		if (PlayerBitPerSample==16)
		{
			*(Mylpv++)=(unsigned char)((s1>>8)&0xFF);
			*(Mylpv++)=(unsigned char)((s1>>16)&0xFF);
		}
		else
		if (PlayerBitPerSample==24)		// MONO 24-Bit
		{
			*(Mylpv++)=(unsigned char)(s1&0xFF);
			*(Mylpv++)=(unsigned char)((s1>>8)&0xFF);
			*(Mylpv++)=(unsigned char)((s1>>16)&0xFF);
		}
		
		SamplesWritten++;
	}
	
	if (SamplePos==(unsigned long)0xFFFFFFFF) dwStopNextTime = dwPos;

	if (useWaveOut)
	{
		waveOutPrepareHeader(hWaveOut, current, sizeof(WAVEHDR));
        waveOutWrite(hWaveOut, current, sizeof(WAVEHDR));
	}
	else
	{
		IDirectSoundBuffer_Unlock(g_pDSBuffer, lpvPtr1, dwBytes1, lpvPtr2, dwBytes2);
	}
    
    return TRUE;
}

unsigned long thisActualSegment;
unsigned int myTimerID;
CWinModInsDlg *theParent;
bool myTimerSet=false;

void CALLBACK myEvent_CallBack(UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	unsigned long dwResult;
	
	if (!theParent->bDone) 
	{ 
		dwResult=RetrieveActualNotifySegment();
		if (dwResult!=thisActualSegment)
		{
			theParent->FillBuffer(thisActualSegment=dwResult);
		}
	}
	else
		theParent->stopPlay();
}

void CALLBACK myWaveOutProc(HWAVEOUT hWaveOut, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
    if (uMsg != WOM_DONE) return;
	thisActualSegment++;
	if (thisActualSegment>=NUM_PLAY_NOTIFICATIONS) thisActualSegment=0;
	theParent->FillBuffer(thisActualSegment);
}

void CWinModInsDlg::stopPlay()
{
	OnStopPlay();
}

void CWinModInsDlg::OnPlayOnceButton() 
{
	HRESULT hRes;

	// Im Hintergrund spielt ein MOD
	if (!PlayerDigiReady) return;
	m_ActualPlayNote.SetCurSel(m_ActualPlayNote.GetTopIndex());

	ActNoteVal=notes[m_ActualPlayNote.GetCurSel()].NoteVal;
	ActSampleData=&ThisMod->Samples[ActSample];

	if (ActSampleData->Sample==NULL) return; // Leeres Sample

	// Zu erst einmal stoppen, falls ntig:
	OnStopPlay();

	// InitDirectSound mit 44kHz, 16Bit, Mono, Handle of Application in "m_hWnd"
	hRes=InitDirectSound(m_hWnd, PlayerFrequ, PlayerBitPerSample, 1, (DWORD_PTR)myWaveOutProc);
	if (hRes!=S_OK) 
		MessageBox("Error: Failed to inititialize DirectSound", "Error:", MB_ICONERROR);

	// Creat the Streaming-Buffer:
	hRes=CreateStreamingBuffer(PlayerFrequ, PlayerBitPerSample, 1, false);
	if (hRes!=S_OK) 
		MessageBox("Error: Failed to create a streaming secondary buffer (DirectSound)", "Error:", MB_ICONERROR);

	dwStopNextTime = 0xFFFF;
	OldSample=0; SampleCount=0, SamplePos=0;

	bDone=false;

	theParent=this;
	
	if (useWaveOut) waveOutPause(hWaveOut);
	
	for (int i=1; i<NUM_PLAY_NOTIFICATIONS; i++) 
		FillBuffer(thisActualSegment=i);
	
	if (!useWaveOut)
	{
		myTimerID=timeSetEvent(1, 0, myEvent_CallBack, 0, TIME_PERIODIC);
		myTimerSet=true;
	}
	StartBuffer();
}

void CWinModInsDlg::OnStopPlay() 
{
	HRESULT hRes;

	// Im Hintergrund spielt ein MOD
	if (!PlayerDigiReady) return;
	bDone=true;

	if (myTimerSet)
	{
		timeKillEvent(myTimerID);
		myTimerSet=false;
	}

	hRes=StopBuffer();	
	if (hRes!=S_OK) 
		MessageBox("Error: Failed to stop DirectSound", "Error:", MB_ICONERROR);

	hRes=FreeDirectSound();
	if (hRes!=S_OK) 
		MessageBox("Error: Failed to free DirectSound", "Error:", MB_ICONERROR);
}

void CWinModInsDlg::OnCheckIsp() 
{
	PlayerISP=!PlayerISP;
	m_CheckISPC.SetCheck(PlayerISP);
	UpdateData(false);
}


void CWinModInsDlg::OnClose() 
{
	// Im Hintergrund spielt ein MOD
	if (PlayerDigiReady) OnStopPlay();

	CDialog::OnClose();
}
